{ lib
}:

{
  overlays = [(final: prev: {
    hostPlatform =
      if prev.hostPlatform != null
      then prev.hostPlatform
      else lib.systems.examples.aarch64-multiplatform;
    scripts = let
      flashromScript = moreFlags: ''
        set -euo pipefail
        ${final.flashrom}/bin/flashrom -p linux_mtd ${moreFlags}
      '';
      flashromWriteScript = moreFlags:
        flashromScript "-w ${final.coreboot}/coreboot.rom ${moreFlags}";
    in prev.scripts // {
      flashrom = flashromScript "$@";
      flash-write-fallback = flashromWriteScript "--fmap -i FALLBACK";
      flash-write-normal = flashromWriteScript "--fmap -i NORMAL";
      flash-write-all = flashromWriteScript "";
    };
  })];
}
